package org.xiss.index;

import net.sf.xanswer.indexing.IndexException;

import org.xiss.index.impl.XmlIndexFactory;

public abstract class XissIndexFactory {
	public static XissIndexFactory newInstance() {
		return new XmlIndexFactory();
	}

	/**
	 * Create an index of a document from scratch.
	 * 
	 * @param xmlPath
	 *            Path to the XML document being indexed
	 * @param outputDir
	 *            Directory to store index files in
	 */
	public abstract IXissIndex createNewFromDocument(String xmlPath,
			String outputDir) throws IndexException;

	/**
	 * Create an empty index at the specified location
	 */
	public abstract IXissIndex createEmpty(String outputDir)
			throws IndexException;

	/**
	 * Open an existing index
	 * 
	 * @param indexDir
	 *            Directory containing the index files
	 */
	public abstract IXissIndex open(String indexDir) throws IndexException;
}
