package org.xiss.index.impl;

import java.util.List;

import org.xiss.index.ElementIndexEntry;
import org.xiss.index.IndexEntry;

class ElementIndexEntryImpl extends ElementIndexEntry {
	private transient List<? extends ElementIndexEntry> myEnclosingList;

	private transient int myIndex;

	/**
	 * Construct an element index entry
	 */
	public ElementIndexEntryImpl(int id, int size, int depth, int parentId) {
		Id = id;
		Size = size;
		Depth = depth;
		ParentId = parentId;
		ValueId = IndexEntry.NONE;
	}

	/**
	 * Construct an attribute index entry or an element index entry with text
	 */
	public ElementIndexEntryImpl(int id, int size, int depth, int parentId,
			int valueId) {
		Id = id;
		Size = size;
		Depth = depth;
		ParentId = parentId;
		ValueId = valueId;
	}

	public boolean equals(Object obj) {
		if (obj == this) {
			return true;
		}
		if (!(obj instanceof ElementIndexEntry)) {
			return false;
		}
		ElementIndexEntry entry = (ElementIndexEntry) obj;
		return (entry.Id == this.Id);
	}

	void setEnclosingList(List<? extends ElementIndexEntry> enclosingList) {
		myEnclosingList = enclosingList;
	}

	List<? extends ElementIndexEntry> getEnclosingList() {
		return myEnclosingList;
	}

	void setIndex(int index) {
		myIndex = index;
	}

	int getIndex() {
		return myIndex;
	}

	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("[");
		sb.append(Id + ":" + Size);
		sb.append(", D=" + Depth);
		sb.append(", P=" + ParentId);
		if (ValueId != IndexEntry.NONE) {
			sb.append(", V=" + ValueId);
		}
		sb.append("]");
		return sb.toString();
	}
}
