package org.xiss.query;

import java.util.Stack;

import net.sf.xanswer.indexing.IndexException;

import org.xiss.index.IXissIndex;

/**
 * Element of a query script.
 */
public interface IXissOperation {
	/**
	 * Run the operation. Must take some parameters from the top of the
	 * evaluation stack, do something with them using the given index and push
	 * results onto the stack.
	 * 
	 * @param index
	 *            Index on which the script is being ran
	 * @param evaluationStack
	 *            The current evaluation stack consisting of temporary query
	 *            results
	 * @throws IndexException
	 */
	void run(IXissIndex index, Stack<IResult> evaluationStack)
			throws IndexException;
}
