package org.xiss.query.impl;

import java.util.ArrayList;
import java.util.HashMap;

import net.sf.xanswer.indexing.IndexException;

import org.xiss.index.IXissIndex;
import org.xiss.index.IndexEntry;
import org.xiss.index.StructureIndexEntry;
import org.xml.sax.Attributes;

/**
 * 
 * Doesn't support namespaces: all namespace URIs are ignored
 * 
 * UNTESTED, DO NOT USE
 */
class AttributesFromIndex implements Attributes {
	private IXissIndex myIndex;

	private int myId;

	private int myAttributesCount;

	private ArrayList<AttributeRecord> myAttributesList;

	private HashMap<String, AttributeRecord> myAttributesDictionary;

	private class AttributeRecord {
		public int Index;

		public String Name;

		public String Value;

		public AttributeRecord(String name, String value) {
			Name = name;
			Value = value;
		}
	}

	public AttributesFromIndex(IXissIndex index, int nodeId)
			throws IndexException {
		myId = nodeId;
		myIndex = index;

		load();
	}

	private void load() throws IndexException {
		myAttributesList = new ArrayList<AttributeRecord>();
		myAttributesDictionary = new HashMap<String, AttributeRecord>();

		StructureIndexEntry entry = myIndex.getStructureIndex().get(myId);
		int aid = entry.FirstAttributeId;
		myAttributesCount = 0;
		while (aid != IndexEntry.NONE) {
			AttributeRecord rec = loadAttributeRecord(entry);
			rec.Index = myAttributesCount++;
			myAttributesList.add(rec);
			myAttributesDictionary.put(rec.Name, rec);
			entry = myIndex.getStructureIndex().get(entry.FirstSiblingId);
		}
	}

	private AttributeRecord loadAttributeRecord(StructureIndexEntry entry)
			throws IndexException {
		String name = myIndex.getNameByNid(entry.NameId);
		String value = myIndex.getValueByVid(entry.ValueId);
		AttributeRecord rec = new AttributeRecord(name, value);
		return rec;
	}

	public int getLength() {
		return myAttributesCount;
	}

	public String getURI(int index) {
		return (index < myAttributesCount) ? "" : null;
	}

	public String getLocalName(int index) {
		return getQName(index);
	}

	public String getQName(int index) {
		return (index >= myAttributesCount) ? ""
				: (myAttributesList.get(index).Name);
	}

	public String getType(int index) {
		return (index >= myAttributesCount) ? null : "CDATA";
	}

	public String getValue(int index) {
		return (index >= myAttributesCount) ? null : (myAttributesList
				.get(index).Value);
	}

	public int getIndex(String uri, String localName) {
		return getIndex(localName);
	}

	public int getIndex(String qName) {
		AttributeRecord rec = myAttributesDictionary.get(qName);
		return (rec == null) ? -1 : (rec.Index);
	}

	public String getType(String uri, String localName) {
		return getType(localName);
	}

	public String getType(String qName) {
		AttributeRecord rec = myAttributesDictionary.get(qName);
		return (rec == null) ? null : "CDATA";
	}

	public String getValue(String uri, String localName) {
		return getValue(localName);
	}

	public String getValue(String qName) {
		AttributeRecord rec = myAttributesDictionary.get(qName);
		return (rec == null) ? null : rec.Value;
	}

}
