package org.xiss.query.impl;

import java.util.List;
import java.util.Stack;

import net.sf.xanswer.indexing.IndexException;

import org.xiss.index.IXissIndex;
import org.xiss.query.IQuery;
import org.xiss.query.IResult;
import org.xiss.query.IXissOperation;

public class XissQuery implements IQuery {
	private List<IXissOperation> myPlan;

	public XissQuery(List<IXissOperation> plan) {
		myPlan = plan;
	}

	public IResult run(IXissIndex index) throws IndexException {
		Stack<IResult> result = new Stack<IResult>();

		for (IXissOperation op : myPlan) {
			op.run(index, result);
		}

		if (result.size() != 1) {
			throw new RuntimeException("Unexpected query result");
		}
		return result.pop();
	}

	public List<IXissOperation> getPlan() {
		return myPlan;
	}

	public String toString() {
		StringBuilder res = new StringBuilder();
		for (IXissOperation op : myPlan) {
			res.append(op.toString() + " ");
		}
		return res.toString().trim();
	}

}
