package org.xiss.query.impl.ast;

import java.util.List;

import org.xiss.query.IXissOperation;
import org.xiss.query.operations.UnionOperation;

public class UnionNode extends AstNode {
	private AstNode myLeft, myRight;

	public UnionNode(AstNode left, AstNode right) {
		myLeft = left;
		myRight = right;
	}

	public void preprocessForGeneration() {
		myLeft.preprocessForGeneration();
		myRight.preprocessForGeneration();
	}

	public void generateCodeTo(List<IXissOperation> script) {
		myLeft.generateCodeTo(script);
		myRight.generateCodeTo(script);
		script.add(new UnionOperation());
	}
}
